-- #NoToLGBT
-- I look forward with bliss anticipation to the day when this atrocious mental disease will dissipate and get thrown down to the darkest depths of fiery hell, where it truly belongs.

local maxplayers = 32 -- MAXPLAYERS; if it ever changes, make sure to change it here too, my dear friends
local basevidwidth = 320 -- BASEVIDWIDTH; same here
local serverplayer = 0

local catenames = {"Score", "Time", "Ring", "Total Ring", "Item Box"}
local colours = {"\x85", "\x84", "\x87", "\x82", "\x81"}

local hudactive = false

local function IsSuperPlayer(p)
	if not (p.charflags & SF_NOSUPERSPRITES) and ((p.powers[pw_super] and p.valid and (p.mo.state < states[S_PLAY_SUPER_TRANS1] or p.mo.state >= states[S_PLAY_SUPER_TRANS6])) or (p.powers[pw_carry] == CR_NIGHTSMODE and skins[p.skin].flags & SF_SUPER))
		return true
	end
	
	return false
end

local function IsGreyPlayer(p)
	if p.spectator or p.playerstate == PST_DEAD or (G_IsSpecialStage(gamemap) and p.exiting)
		return true
	end

	return false
end

local function strcat_cr(j, str, num)
	local nz = ""
	if (num > 0)
		nz = "+"
	end
	
	str[1] = $ .. " " .. colours[j] .. nz .. num .. " "
end

local function RankingsSort(a, b)
	return a.count > b.count
end

-- Let's care for resolutions other than our own! =D
local function GetAspectRatioOffsets(v)
	local xoffset = 0
	local yoffset = 0
	local ratio = FRACUNIT*v.width()/v.height()
	
	if (ratio < FRACUNIT*16/9)
		xoffset = 30
		yoffset = 10
	end
	
	return xoffset, yoffset
end

local function HU_drawPing(v, x, y, ping, notext, flags)
	local numbars = 0
	local barcolor = 31
	local yoffset = 6
	local fullflg = V_ALLOWLOWERCASE|flags
	local pingstr = ping + "ms"
	local dx = x+1 - v.stringWidth(pingstr, fullflg, "small")/2
	
	if ping < 128
		numbars = 3
		barcolor = 112
	elseif ping < 256
		numbars = 2
		barcolor = 73
	elseif ping != UINT32_MAX
		numbars = 1
		barcolor = 35
	end
	
	if ping != UINT32_MAX and (not notext or v.width() >= 640)
		v.drawString(dx, y+4, pingstr, fullflg, "small")
	end
	
	for i=0,2
		local xst = x+2 * (i-1)
	
		v.drawFill(xst, y+yoffset-4, 2, 8-yoffset, 31|flags)
		
		if i < numbars
			v.drawFill(xst, y+yoffset-3, 1, 8-yoffset-1, barcolor|flags)
		end
		
		yoffset = $ - 2
	end
	
	if ping == UINT32_MAX
		local nopingicon = v.cachePatch("NOPINGICON")
		v.drawScaled((x+4-nopingicon.width/2)*FRACUNIT, (y+9-nopingicon.height/2)*FRACUNIT, FRACUNIT/2, nopingicon, 0)
	end
end

local function HU_drawGametype(v)
	local strvalue
	
	--if gametype < 0 or gametype >= gametypecount return end
	
	--strvalue = Gametype_Names(gametype)
	
	strvalue = "Competition"
	
	local y = 192
	if (splitscreen) y = $ - 8 end
	
	v.drawString(4, y, strvalue, 0)
	
end

local crdata = {}

local function HU_DrawTabRankings(v, x, y, tab, scorelines, type)
	local whiteplayer = consoleplayer

	local xoffset = -GetAspectRatioOffsets(v)
	
	local linex = 1
	local linelen = 318

	if type == 1 xoffset = $ + 20
	elseif type == 2 xoffset = $ + 30
	end

	if type == 0
		v.drawFill(1, 26, 318, 1, 0) -- Draw a horizontal line because it looks nice~!
	else
		local linex = 1 - xoffset
		local linelen = 318 + xoffset*2
	
		v.drawFill(160, 26, 1, 154, 0)
		v.drawFill(linex, 26, linelen, 1, 0)
		v.drawFill(linex, 180, linelen, 1, 0)
	end
	
	local x2 = 6
	for i=1,#catenames
		v.drawString(x2, 14, colours[i]..catenames[i], 0, "thin")
		local w = v.stringWidth(catenames[i], 0, "thin")
		x2 = x2 + w + 4
	end
	
	local livesback = v.cachePatch("STLIVEBK")
	
	for i=1,scorelines
		local tabplayer = players[tab[i].num]
		local greycheck = IsGreyPlayer(tabplayer)
		local supercheck = IsSuperPlayer(tabplayer)
		
		local nameflags = V_ALLOWLOWERCASE
		local faceflags = 0
		local textflags = V_ALLOWLOWERCASE
		if #whiteplayer == tab[i].num
			nameflags = $ | V_YELLOWMAP
		end
		
		if greycheck
			nameflags = $ | V_60TRANS
			textflags = $ | V_60TRANS
			faceflags = $ | V_80TRANS
		end
		
		local compactmode = 0
		local scoreoffset = 265
		local scoreyoffset = 0
		if type == 1 scoreoffset = 100
		elseif type == 2 scoreoffset = 128
		end
		
		if not splitscreen
			if tab[i].num ~= serverplayer
				local ping = tabplayer.ping
				if tabplayer.quittime ping = UINT32_MAX end
				if type < 2
					HU_drawPing(v, x+scoreoffset, y, ping, false, 0)
				else
					HU_drawPing(v, x+135, y+1, ping, false, 0)
				end
			end
		end
		
		local drawname = ~tabplayer.quittime or (leveltime / (TICRATE/2) & 1)
		
		if type < 2
			v.drawScaled((x-xoffset)*FRACUNIT, (y-4)*FRACUNIT, FRACUNIT/2, livesback, faceflags)
		end
		
		local mo = tabplayer.mo or tabplayer.realmo
		
		local name = tabplayer.name
		local face = v.getSprite2Patch(mo.skin, SPR2_XTRA, 0, 0)
		local colour = v.getColormap(TC_DEFAULT, tabplayer.skincolor)
		
		local namecap = 21
		
		if name
			if string.len(name) >= namecap
				name = string.sub($, 1, namecap)
			end
		end
		
		local scorestring = tab[i].count
		if type > 0
			scorestring = $ .. " "
		
			local dat = crdata[#tabplayer+1]
			local tbcr = {dat.score+1, dat.time+1, dat.rings+1, dat.totalring+1, dat.itembox+1}
			
			local sh = "#"
			if type == 2 sh = "" end
			
			for j = 1,5
				scorestring = $ .. colours[j] .. sh .. tbcr[j] .. " "
			end
			scorestring = $ .. "\x80"
		end
		
		local namew = v.stringWidth(name, 0)
		local namethinw = v.stringWidth(name, 0, "thin")
		local scorew = v.stringWidth(scorestring, 0, "thin")
		
		local startname = x + 20 - xoffset
		if type == 2
			startname = $ - 10
		end
		
		local len = string.len(name)
		
		if startname + namethinw >= x + scoreoffset - scorew
			if type == 2
				while startname + namethinw >= x + scoreoffset - scorew
					len = $ - 1
					name = string.sub($, 1, len)
					namethinw = v.stringWidth(name, 0, "thin")
				end
			else
				compactmode = 2
			end
		elseif startname + namew >= x + scoreoffset - scorew
			compactmode = 1
		end
		
		if compactmode == 2 scoreyoffset = 4 end
		
		if drawname
			if type == 0
				v.drawString(startname, y, name, nameflags)
			elseif type == 1
				v.drawString(startname, y-scoreyoffset, name, nameflags, "thin")
			else
				v.drawString(startname, y, name, nameflags, "thin")
			end
		end
		
		if type < 2
			v.drawScaled((x-xoffset)*FRACUNIT, (y-4)*FRACUNIT, FRACUNIT/2, face, faceflags, colour)
		
			v.drawString(x-xoffset, y+4, tabplayer.lives.."x", textflags, "right")
			v.drawString(x+scoreoffset, y+scoreyoffset, scorestring, textflags, "thin-right")
		else
			v.drawScaled((x-xoffset)*FRACUNIT, y*FRACUNIT, FRACUNIT/4, face, faceflags, colour)
		
			v.drawString(x-1-xoffset, y, tabplayer.lives, textflags, "thin-right")
		
			if compactmode < 2
				v.drawString(x+scoreoffset, y, scorestring, textflags, "thin-right")
			else
				v.drawString(x+scoreoffset-25, y+2, scorestring, textflags, "small-thin-right")
			end
		end
		
		local pass = false
		
		if type == 0 and #crdata
		if crdata[#tabplayer+1]
			pass = true
		end
		end
		
		if pass
		local datapos = {{x = x+215, y = y-4, data = "score"}, {x = x+215, y = y+4, data = "time"}, {x = x+230, y = y-4, data = "rings"}, {x = x+230, y = y+4, data = "totalring"}, {x = x+245, y = y, data = "itembox"}}
		
		for j=1,5
			v.drawString(datapos[j].x, datapos[j].y, colours[j].."#"..crdata[#tabplayer+1][datapos[j].data]+1, textflags, "thin-right")
		end
		end
		
		if type < 2
			y = $ + 16
		else
			y = $ + 9
			
			if i == 16+1
				y = 32
				x = $ + basevidwidth/2 + xoffset
			end
		end
		
		if type == 1
			if y > 160
				y = 32
				x = $ + basevidwidth/2 + xoffset
			end
		end
	end
end

local function HU_ClassicRaceGetData()
	if (gametype ~= GT_COMPETITION) return end

	while #crdata
		table.remove(crdata)
	end
	
	for i=0,maxplayers-1
		local intable = {pts = 0, score = 0, time = 0, rings = 0, totalring = 0, itembox = 0}
		table.insert(crdata, intable)
	end
	
	for i=0,maxplayers-1
		if not players[i] continue end
	
		for j=0,maxplayers-1
			if not players[j] continue end
		
			local ita = {players[i].score, -players[i].realtime, max(players[i].rings, 0), players[i].totalring, players[i].numboxes}
			local jta = {players[j].score, -players[j].realtime, max(players[j].rings, 0), players[j].totalring, players[j].numboxes}
			local dta = {"score", "time", "rings", "totalring", "itembox"}
		
			for k=1,#ita
				if (ita[k] >= jta[k])
					if (j ~= i)
						crdata[i+1].pts = $ + 1
					end
				else
					crdata[i+1][dta[k]] = $ + 1
				end
			end
		end
	end
end

--local function StatsReset(player)
--	player.comp_pts = 0
--	player.comp_score = 0
--	player.comp_time = 0
--	player.comp_rings = 0
--	player.comp_totalring = 0
--	player.comp_itembox = 0
--end

--addHook("PlayerSpawn", function(player)
--	if gamestate ~= GS_LEVEL return end
--	
--	if player.comp_pts == nil
--		StatsReset(player)
--	end
--end)

local function LoadHUD()
	if (gametype ~= GT_COMPETITION)
		if not hudactive return end
		
		hudactive = false
		
		hud.enable("score")
		hud.enable("time")
		hud.enable("rings")
		hud.enable("rankings")
		
		return
	end
	
	if hudactive return end
	
	hudactive = true
	
	hud.disable("score")
	hud.disable("time")
	hud.disable("rings")
	hud.disable("rankings")
end

local function CompetitionHUD(v, p)
	if (splitscreen) return end -- Does not work in splitscreen
	if (gametype ~= GT_COMPETITION) return end -- Obviously =P
	if (#crdata ~= maxplayers) return end -- Data is not ready yet =/

	local tablep = {crdata[#p+1].score, crdata[#p+1].time, crdata[#p+1].rings, crdata[#p+1].totalring, crdata[#p+1].itembox}

	local xoffset, yoffset = GetAspectRatioOffsets(v)

	--print(xoffset .. " " .. yoffset)

	local x = -20
	
	for i = 1,#catenames
		v.drawString(x+xoffset, yoffset, colours[i] .. catenames[i], 0, "thin")
		local w = v.stringWidth(catenames[i], 0, "thin")
		x = $ + w + 4
	end
	
	local j = 1
	local hudstring = "Stats:  "
	hudstring = $ .. " " .. crdata[#p+1].pts .. " pts "
	hudstring = $ .. " " .. colours[j] .. p.score .. " (#" .. tablep[1]+1 .. ") "
	j = $ + 1
	
	local minutes = G_TicsToMinutes(p.realtime, false)
	local seconds = G_TicsToSeconds(p.realtime, false)
	local cseconds = G_TicsToCentiseconds(p.realtime, false)
	
	-- UGLY HACK!!! I would be very grateful if someone explained how to do printf-like string formatting in BLUA...
	if (seconds < 10) seconds = "0" .. $ end
	if (cseconds < 10) cseconds = "0" .. $ end
	
	hudstring = $ .. " " .. colours[j] .. minutes .. ":" .. seconds .. "." .. cseconds .. " (#" .. tablep[2]+1 .. ") "
	j = $ + 1
	
	hudstring = $ .. " " .. colours[j] .. max(p.rings, 0) .. " (#" .. tablep[3]+1 .. ") "
	j = $ + 1
	
	hudstring = $ .. " " .. colours[j] .. p.totalring .. " (#" .. tablep[4]+1 .. ") "
	j = $ + 1
	
	hudstring = $ .. " " .. colours[j] .. p.numboxes .. " (#" .. tablep[5]+1 .. ") "
	
	v.drawString(-20+xoffset, 12+yoffset, hudstring, 0, "thin")
	
	local next = {}
	local prev = {}
	local first = {}
	
	for j=1,5
		next[j] = #p
		prev[j] = #p
		first[j] = #p
	end
	
	for z in players.iterate
		if (#z == #p) continue end
		
		local tablez = {crdata[#z+1].score, crdata[#z+1].time, crdata[#z+1].rings, crdata[#z+1].totalring, crdata[#z+1].itembox}
		
		for j=1, #next
			if (tablez[j] == tablep[j]-1)
				next[j] = #z
			elseif (tablez[j] == tablep[j]+1)
				prev[j] = #z
			end
			
			if (tablez[j] == 0)
				first[j] = #z
			end
		end
	end
	
	local next_data = {}
	local prev_data = {}
	local first_data = {}
	local dta = {"score", "realtime", "rings", "totalring", "numboxes"}
	
	for j=1,5
		local pnext = players[next[j]]
		local pprev = players[prev[j]]
		local pfirst = players[first[j]]
	
		if not pnext next_data[j] = p[dta[j]] else next_data[j] = pnext[dta[j]] end
		if not pprev prev_data[j] = p[dta[j]] else prev_data[j] = pprev[dta[j]] end
		if not pfirst first_data[j] = p[dta[j]] else first_data[j] = pfirst[dta[j]] end
	end
	
	hudstring = "Next:  "
	
	local hudstrtable = {hudstring}
	
	strcat_cr(1, hudstrtable, next_data[1] - p[dta[1]])
	strcat_cr(3, hudstrtable, max(next_data[3], 0) - max(p[dta[3]], 0))
	strcat_cr(4, hudstrtable, next_data[4] - p[dta[4]])
	strcat_cr(5, hudstrtable, next_data[5] - p[dta[5]])
	
	hudstrtable[1] = $ .. "  \x80Prev:  "
	
	strcat_cr(1, hudstrtable, prev_data[1] - p[dta[1]])
	strcat_cr(3, hudstrtable, max(prev_data[3], 0) - max(p[dta[3]], 0))
	strcat_cr(4, hudstrtable, prev_data[4] - p[dta[4]])
	strcat_cr(5, hudstrtable, prev_data[5] - p[dta[5]])
	
	hudstrtable[1] = $ .. "  ".."\x80".."First:  "
	
	strcat_cr(1, hudstrtable, first_data[1] - p[dta[1]])
	strcat_cr(3, hudstrtable, max(first_data[3], 0) - max(p[dta[3]], 0))
	strcat_cr(4, hudstrtable, first_data[4] - p[dta[4]])
	strcat_cr(5, hudstrtable, first_data[5] - p[dta[5]])
	
	v.drawString(-20+xoffset, 20+yoffset, hudstrtable[1], 0, "thin")
end

local function CompetitionHUDTab(v)
	if (splitscreen) return end -- Does not work in splitscreen
	if (gametype ~= GT_COMPETITION) return end -- Obviously =P

	HU_drawGametype(v)

	local tab = {}

	for i=0,maxplayers-1
		local ta = {num = -1, name = "", count = -1, color = 0, emeralds = 0}
		
		table.insert(tab, ta)
	end

	local hasspectators = G_GametypeHasSpectators()
	
	local scorelines = 0
	for p in players.iterate
		if (hasspectators and p.spectator) continue end
		
		tab[scorelines+1].count = crdata[#p+1].pts
		tab[scorelines+1].num = #p
		tab[scorelines+1].color = p.skincolor
		tab[scorelines+1].name = p.name
		tab[scorelines+1].emeralds = p.powers[pw_emeralds]
		
		scorelines = $ + 1
	end
	
	table.sort(tab, RankingsSort)
	
	local type = 0
	local bx = 40
	local by = 32
	if scorelines <= 9
	elseif scorelines <= 18
		bx = 32
		type = 1
	else
		bx = 14
		by = 28
		type = 2
	end
	HU_DrawTabRankings(v, bx, by, tab, scorelines, type)
end

--local function HUDReset(mapnum)
--	for player in players.iterate do
--		StatsReset(player)
--	end
--end

hud.add(CompetitionHUD, "game")
hud.add(CompetitionHUDTab, "scores")
--addHook("MapLoad", HUDReset)
addHook("ThinkFrame", HU_ClassicRaceGetData)
addHook("MapChange", LoadHUD)
addHook("PlayerJoin", LoadHUD)